from direct.distributed.DistributedObject import DistributedObject
import random

class DistributedShuffle(DistributedObject):
    """The distributed shuffle class is used for getting a shuffled
    deck from the server and tell if we are the first to select a card
    value"""
    def __init__(self, cr):
	"""Basic init function which just initialise the
	DistributedObject"""
        DistributedObject.__init__(self, cr)

    def announceGenerate(self):
        """This method is called after generate(), after all of the
        required fields have been filled in.  At the time of this call,
        the distributed object is ready for use."""
        DistributedObject.announceGenerate(self)
        self.getDeck()

    def disable(self):
	"""Function which is needed by every DistributedObject. Will
	handle the removal of this node"""
        # Take it out of the scene graph.
        self.detachNode()
        DistributedObject.disable(self)

    def detachNode(self):
	# nothing to do here
	pass

    def getDeck(self):
	"""This function will send a request to the server to get a
	shuffled carddeck for the player"""
	print "requesting deck from server"
	self.sendUpdate("requestDeck", [0])

    def updateDeck(self, context, deck, startTurn):
	"""This function will be called if we get a message from the
	server. It will get the shuffled deck for the player and a value
	if we are the player that starts the game with the first turn."""
	print "got our deck from the server"
	base.messenger.send("gotDeck", [deck])
	base.messenger.send("setTurn", [startTurn])
