from direct.distributed.ServerRepository import ServerRepository
# the main server class
class SNCServerRepository(ServerRepository):
    """The server repository class"""
    def __init__(self):
        """initialise the server class"""
        # get the port number from the configuration file
        # if it doesn't exist, use 4400 as the default
        tcpPort = base.config.GetInt('server-port', 4400)
        # list of all needed .dc files
        dcFileNames = ['direct.dc', 'net.dc']
        # initialise the server on this machine with the
        # port number and the dc filenames
        ServerRepository.__init__(self, tcpPort, dcFileNames = dcFileNames)

    def getShuffledDecks(self):
        """This method will shuffle a complete card deck and return it
        split up in two parts (for player 1 and player 2) at the end"""
        import random
        random.seed()
        self.allcardIDs = []
        self.allcardIDs.extend(range(1, 21))
        self.cardsPlayer1 = []
        self.cardsPlayer2 = []

        print "shuffling deck"
        # fill two decks (for player 1 and 2) randomly with cards
        for i in range(10):
            c1 = random.choice(self.allcardIDs)
            self.allcardIDs.remove(c1)
            self.cardsPlayer1.append(c1)
            c2 = random.choice(self.allcardIDs)
            self.allcardIDs.remove(c2)
            self.cardsPlayer2.append(c2)
        print "shuffling done"
        # return both card decks
        return [self.cardsPlayer1, self.cardsPlayer2]
